=== modified file 'NEWS'
--- NEWS	2007-11-28 23:56:13 +0000
+++ NEWS	2007-11-29 00:22:51 +0000
@@ -68,13 +68,6 @@
 
   BUG FIXES:
 
-   * Fix possible error in insert_data_stream when copying between 
-     pack repositories over bzr+ssh or bzr+http.  
-     KnitVersionedFile.get_data_stream now makes sure that requested
-     compression parents are sent before any delta hunks that depend 
-     on them.
-     (Martin Pool, #164637)
-
    * A progress bar has been added for knitpack -> knitpack fetching.
      (Robert Collins, #157789, #159147)
 
@@ -109,6 +102,13 @@
    * Fix multiple connections during checkout --lightweight.
      (Vincent Ladeuil, #159150)
 
+   * Fix possible error in insert_data_stream when copying between 
+     pack repositories over bzr+ssh or bzr+http.  
+     KnitVersionedFile.get_data_stream now makes sure that requested
+     compression parents are sent before any delta hunks that depend 
+     on them.
+     (Martin Pool, #164637)
+
    * Fix typo in limiting offsets coalescing for http, leading to
      whole files being downloaded instead of parts.
      (Vincent Ladeuil, #165061)
@@ -116,6 +116,10 @@
    * FTP server errors don't error in the error handling code.
      (Robert Collins, #161240)
 
+   * Give a clearer message when a pull fails because the source needs
+     to be reconciled.
+     (Martin Pool, #164443)
+
    * It is clearer when a plugin cannot be loaded because of its name, and a
      suggestion for an acceptable name is given. (Daniel Watkins, #103023)
 

=== modified file 'bzrlib/knit.py'
--- bzrlib/knit.py	2007-11-28 05:35:06 +0000
+++ bzrlib/knit.py	2007-11-29 00:22:51 +0000
@@ -770,11 +770,19 @@
                     # line-delta is no use unless we have its parent.
                     # Fetching from a broken repository with this problem
                     # shouldn't break the target repository.
+                    #
+                    # See https://bugs.launchpad.net/bzr/+bug/164443
                     if not self._index.has_version(parents[0]):
                         raise KnitCorrupt(
                             self.filename,
-                            'line-delta from stream references '
-                            'missing parent %s' % parents[0])
+                            'line-delta from stream '
+                            'for version %s '
+                            'references '
+                            'missing parent %s\n'
+                            'Try running "bzr check" '
+                            'on the source repository, and "bzr reconcile" '
+                            'if necessary.' %
+                            (version_id, parents[0]))
                 self._add_raw_records(
                     [(version_id, options, parents, length)],
                     reader_callable(length))

